------------------------------------------------------------------------------------------
-- UI file
-- Written by Homeopatix
-- 7 january 2021
------------------------------------------------------------------------------------------
-- create the window
------------------------------------------------------------------------------------------
centerWindow = {};
centerLabel = {};
centerQS = {};

function GenerateWindow()

		local horizontalPosition = 20 ;
		local verticalPosition = 40;
		local nbrSlot = 0;
		local windowWidth = (settings["nbrSlots"]["nbr"] * 42) + 38;
		local windowHeight = 0;
		if(settings["useRandomMont"]["value"] == true)then
			windowHeight = (settings["nbrLine"]["nbr"] * 42) + 130;
		else
			windowHeight = (settings["nbrLine"]["nbr"] * 42) + 60;
		end
		local totalSlots = tonumber(settings["nbrSlots"]["nbr"]) * tonumber(settings["nbrLine"]["nbr"]);

		HorseStableWindow=Turbine.UI.Lotro.GoldWindow(); 
		HorseStableWindow:SetSize(windowWidth, windowHeight); 
		HorseStableWindow:SetText(Strings.PluginName); 

		HorseStableWindow.Message=Turbine.UI.Label(); 
		HorseStableWindow.Message:SetParent(HorseStableWindow); 
		HorseStableWindow.Message:SetSize(150,10); 
		HorseStableWindow.Message:SetPosition(windowWidth/2 - 75, windowHeight - 20 ); 
		HorseStableWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
		HorseStableWindow.Message:SetText(Strings.PluginText); 

		HorseStableWindow:SetZOrder(0);
		HorseStableWindow:SetWantsKeyEvents(true);

		HorseStableWindow:SetWantsUpdates(true);

		HorseStableWindow:SetPosition(settings["windowPosition"]["xPos"], settings["windowPosition"]["yPos"]);

		------------------------------------------------------------------------------------------
		-- center window --
		------------------------------------------------------------------------------------------

		for i=1, totalSlots do
			if(nbrSlot == tonumber(settings["nbrSlots"]["nbr"]))then
				verticalPosition = verticalPosition + 42;
				nbrSlot = 0;
				horizontalPosition = 20;
			end
			
			centerWindow[i] = Turbine.UI.Extensions.SimpleWindow();
			centerWindow[i]:SetSize( 40 , 40 );
			centerWindow[i]:SetParent( HorseStableWindow );
			centerWindow[i]:SetPosition( horizontalPosition , verticalPosition);
			centerWindow[i]:SetVisible( true );
			if(i == totalSlots)then
				centerWindow[i]:SetBackColor( Turbine.UI.Color( .3, .9, .1, 0 ) );
			else
				centerWindow[i]:SetBackColor( Turbine.UI.Color( .3, .5, .7, .5) );
			end

			centerLabel = Turbine.UI.Label();
			centerLabel:SetParent(centerWindow[i]);
			centerLabel:SetPosition( 0, 0 );
			centerLabel:SetSize( 40, 40  );
			centerLabel:SetText( "" );
			centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
			centerLabel:SetZOrder(-1);
			centerLabel:SetMouseVisible(false);

			centerQS[i] = Turbine.UI.Lotro.Quickslot();
			centerQS[i]:SetParent( centerWindow[i] );
			centerQS[i]:SetPosition( 1, 1 );
			centerQS[i]:SetSize( 36, 36 );
			centerQS[i]:SetUseOnRightClick(false);

			nbrSlot = nbrSlot + 1;
			horizontalPosition = horizontalPosition + 42;
		end

		if(settings["useRandomMont"]["value"] == true)then
			centerLabel = Turbine.UI.Label();
			centerLabel:SetParent(HorseStableWindow);
			centerLabel:SetPosition( windowWidth/2 - 150 , verticalPosition + 35);
			centerLabel:SetSize( 300, 40  );
			centerLabel:SetText( Strings.PluginUI2 );
			centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
			centerLabel:SetZOrder(-1);
			centerLabel:SetMouseVisible(false);

			centerWindowRandom = Turbine.UI.Extensions.SimpleWindow();
			centerWindowRandom:SetSize( 40 , 40 );
			centerWindowRandom:SetParent( HorseStableWindow );
			centerWindowRandom:SetPosition( windowWidth/2 - 20 , verticalPosition + 65);
			centerWindowRandom:SetVisible( true );

			centerLabel = Turbine.UI.Label();
			centerLabel:SetParent(centerWindowRandom);
			centerLabel:SetPosition( 0, 0 );
			centerLabel:SetSize( 40, 40  );
			centerLabel:SetText( "" );
			centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
			centerLabel:SetZOrder(-1);
			centerLabel:SetMouseVisible(false);

			centerQSRandom = Turbine.UI.Lotro.Quickslot();
			centerQSRandom:SetParent( centerWindowRandom );
			centerQSRandom:SetPosition( 1, 1 );
			centerQSRandom:SetSize( 36, 36 );
			centerQSRandom:SetUseOnRightClick(false);
		end
------------------------------------------------------------------------------------------
-- setting the datas	
------------------------------------------------------------------------------------------
	SettingTheShortCuts();
	DragAndDrop();
	DeleteShortCutes();
	MouseClickHandler();
	EscapeKeyPressed();
	ClosingTheWindow();
	if(settings["useRandomMont"]["value"] == true)then
		SettingTheShortCutsForRandomMonture();
		MouseClickHandlerForRandomMount();
	end
end
------------------------------------------------------------------------------------------
-- setting the shortcuts	
------------------------------------------------------------------------------------------
function SettingTheShortCuts()
		local totalSlots = tonumber(settings["nbrSlots"]["nbr"]) * tonumber(settings["nbrLine"]["nbr"]);

		for i=1, totalSlots do
			if(settings["shortcuts"]["Data" .. i] ~= "") then
				centerQS[i]:SetShortcut( Turbine.UI.Lotro.Shortcut( settings["shortcuts"]["Type"], settings["shortcuts"]["Data" .. i] ) );
			end
		end
end

local u = 0 -- don't delete
function Random(x, y)
    u = u + 1
    if x ~= nil and y ~= nil then
        return math.floor(x +(math.random(math.randomseed(Turbine.Engine.GetLocalTime()+u))*999999 %y))
    else
        return math.floor((math.random(math.randomseed(Turbine.Engine.GetLocalTime()+u))*100))
    end
end

function SettingTheShortCutsForRandomMonture()
		local totalSlots = tonumber(settings["nbrSlots"]["nbr"]) * tonumber(settings["nbrLine"]["nbr"]);

		local nbrMont = 0;
		for i=1, totalSlots do
			if(settings["shortcuts"]["Data" .. i] ~= "") then
				nbrMont = nbrMont + 1;
			end
		end

		local randomMonture = 0;
		randomMonture = Random(1, nbrMont);
		centerQSRandom:SetShortcut( Turbine.UI.Lotro.Shortcut( settings["shortcuts"]["Type"], settings["shortcuts"]["Data" .. randomMonture] ) );

		if(randomMonture == totalSlots)then
			centerWindowRandom:SetBackColor( Turbine.UI.Color( .3, .9, .1, 0 ) );
		else
			centerWindowRandom:SetBackColor( Turbine.UI.Color( .3, .5, .7, .5) );
		end
end
------------------------------------------------------------------------------------------
-- setting the shortcuts for drag and drop	
------------------------------------------------------------------------------------------
function DragAndDrop()
	local totalSlots = tonumber(settings["nbrSlots"]["nbr"]) * tonumber(settings["nbrLine"]["nbr"]);

	for i=1, totalSlots do
		centerQS[i].DragDrop = function(sender, args)
			local tmp = Turbine.UI.Lotro.Quickslot();

			tmp = centerQS[i]:GetShortcut();
			tmp = tmp:GetData();

			--Turbine.Shell.WriteLine(tmp);

			settings["shortcuts"]["Data" .. i] = tmp;

			SaveSettings();
		end
	end
end
------------------------------------------------------------------------------------------
-- delete the shortcut with mouse wheel
------------------------------------------------------------------------------------------
function DeleteShortCutes()
	local totalSlots = tonumber(settings["nbrSlots"]["nbr"]) * tonumber(settings["nbrLine"]["nbr"]);

	for i=1, totalSlots do
		centerQS[i].MouseWheel = function(sender, args)
			settings["shortcuts"]["Data" .. i] = ""; 
			centerQS[i]:SetShortcut(Turbine.UI.Lotro.Shortcut());
			SaveSettings();
		end
	end
end
------------------------------------------------------------------------------------------
-- MousCLick Handler
------------------------------------------------------------------------------------------
function MouseClickHandler()
	local totalSlots = tonumber(settings["nbrSlots"]["nbr"]) * tonumber(settings["nbrLine"]["nbr"]);

	for i=1, totalSlots do
		centerQS[i].MouseClick = function(sender, args)
			HorseStableWindow:SetVisible(false);
			settings["isWindowVisible"]["isWindowVisible"] = false;
			SaveSettings();
		end
	end
end
------------------------------------------------------------------------------------------
-- MousCLick Handler
------------------------------------------------------------------------------------------
function MouseClickHandlerForRandomMount()
	centerQSRandom.MouseClick = function(sender, args)
		HorseStableWindow:SetVisible(false);
		settings["isWindowVisible"]["isWindowVisible"] = false;
		SaveSettings();
	end
end
------------------------------------------------------------------------------------------
-- Closing window handler
------------------------------------------------------------------------------------------
function ClosingTheWindow()
	function HorseStableWindow:Closing(sender, args)
		settings["isWindowVisible"]["isWindowVisible"] = false;
		SaveSettings();
	end
end
------------------------------------------------------------------------------------------
-- updating the window
------------------------------------------------------------------------------------------
function UpdateWindow()
	GenerateWindow();
end